;12 Feb 2016
;ORG 0000H

;LJMP MAIN

seq4steps EQU 7	   
seq4:  	dw 1111110000111111b  ;mark leds on or off
		dw 1111100000011111b  
		dw 1111000000001111b
		dw 1110000000000111b  
		dw 1100000000000011b  
		dw 1000000000000001b  
        dw 0  
	   
	 


seq2steps EQU 9
seq2:  		        dw 1111110000000000b  ;mark leds on or off
			dw 0111110010000000b
			dw 0011110011000000b
			dw 0001110011100000b
			dw 0000110011110000b
			dw 0000010011111000b
			dw 0000000011111100b
			dw 0000000001111110b
        	        dw 0000000000111111b
	

				  
seq1steps EQU 17
seq1:      dw 0000000000000000b
           dw 1000000000000000b  ;mark leds on or off
           dw 1100000000000000b  
	   dw 1110000000000000b
	   dw 1111000000000000b  
	   dw 1111100000000000b  
	   dw 1111110000000000b  
	   dw 1111111000000000b  
	   dw 1111111100000000b  	
           dw 1111111110000000b  
	   dw 1111111111000000b  
	   dw 1111111111100000b
	   dw 1111111111110000b  
	   dw 1111111111111000b  
	   dw 1111111111111100b
	   dw 1111111111111110b  
	   dw 1111111111111111b
	  	 
;dw 1111111100000000b =	dw 0ff00h=db 0ffh,0h =  db 255,0 
	
   
table_count equ 40h
tmp_table_count equ 41h



;MAIN:

;bigloop:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
program1:
       mov table_count,#seq1steps
       MOV R3,#05
       D1: mov dptr,#seq1  ;address pattern block
       call displayloop
       ;call longdelay    ;pause
       ;JNB P3.5,D1
       ;DJNZ R3,D1
       
       ;MOV R3,#05
       mov dptr,#seq1    ;address pattern block
       call reversedisplayloop
       ;call longdelay    ;pause
       ;JNB P3.5,D1
       DJNZ R3,D1
		  ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  program0:      mov table_count,#seq2steps
        MOV R3,#05
        D3: mov dptr,#seq2  ;address pattern block
	call displayloop
	;call longdelay    ;pause
	;;JNB P3.5,D3
	DJNZ R3,D3
	
	MOV R3,#05
        D4:  mov dptr,#seq2  ;address pattern block
	call reversedisplayloop;
	;call longdelay
	;JNB P3.5,D4
	DJNZ R3,D4
		ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
  program2:      mov table_count,#seq4steps
        MOV R3,#05
        D5: mov dptr,#seq4  ;address pattern block
	call displayloop
	;call longdelay    ;pause
	;JNB P3.5,D5
	DJNZ R3, D5
	
	MOV R3,#05
        D6: mov dptr,#seq4  ;address pattern block
	call reversedisplayloop
	;call longdelay    ;pause
;	JNB P3.5,D6
	DJNZ R3, D6
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;jmp bigloop
	


displayloop:              
     mov A,table_count  ;copy the number of lines to display
     mov tmp_table_count,A
	 
d_loop:
     mov A,#0
     movc A,@A+dptr ;get the top 6 bits
	 call mirrorbyte; ;reverse pattern to suit hardware
	 mov P0,A      ;display pattern
	 inc dptr    
	 mov A,#0
     movc A,@A+dptr ;get the low 6 bits
	 call mirrorbyte
	 mov P2,A
	 inc dptr
	 call delay2       ;pause
	 djnz tmp_table_count,d_loop	;next line of table
     ret	 



reversedisplayloop:
     mov A,table_count  ;copy the number of lines to display
     mov tmp_table_count,A 
	 rl A ;2 bytes per line
inc_dptr:	 
	 dec A
	 jz noinc_dptr
	 inc dptr
	 jmp inc_dptr
noinc_dptr:	 
r_loop:	 

     mov A,#0
     movc A,@A+dptr ;get the top 6 bits
	 call mirrorbyte; ;reverse pattern to suit hardware
	 mov P2,A      ;display pattern
	 ;8051 has no "dec dptr" instruction, so do it the hard way.
	 dec DPL
	 MOV R7,DPL
	 cjne R7,#255,rdl1
	 dec dph
rdl1:	 
	
	 mov A,#0
     movc A,@A+dptr ;get the low 6 bits
	 call mirrorbyte
	 mov P0,A
	 dec DPL
	 MOV R7,DPL
	 cjne R7,#255,rdl2
	 dec dph
rdl2:

	 call delay2       ;pause
	 djnz tmp_table_count,r_loop
     ret	 




longdelay:    ;pause
     call delay2;
	 call delay2;
	 call delay2;
	 call delay2;
	 ret
	 
   
;delay2:



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   ; mov r2,#1
;outloop:  
    ;MOV R0,#0FFH
;INLOP1:
  ; MOV R1,#0FFH	
;	DJNZ R1,$
	;DJNZ R0,INLOP1
;	DJNZ R2,outloop;
	;ret
	
	
mirrorbyte: ;Reverse the bit order to suit the display hardware
            ;Bit 7 becomes bit 0
    MOV R0,#0 
    MOV R1,#8  ;8 bits
mirrorloop:	
	RLC A;  ;move top bit into carry
	XCH A,R0  ;work on new copy
	RRC A;    ;shift right, carry become top bit
    XCH A,R0;  ;back to normal
	DJNZ R1,mirrorloop;   ;next bit
	XCH A,R0              ;return new pattern in A
	ret
	

				
;END 



